local T, C, L, _ = unpack(select(2, ...))
if C.skins.meetinghorn ~= true then return end

----------------------------------------------------------------------------------------
--	MeetingHorn skin
----------------------------------------------------------------------------------------
if IsAddOnLoaded("MeetingHorn") then
	local MeetingHorn = LibStub('AceAddon-3.0'):GetAddon('MeetingHorn')
	local ListView = MeetingHorn:GetClass('UI.ListView')
	
	local frame = MeetingHornMainPanel
	for k, child in pairs ({frame:GetChildren()}) do
		if k == 3 then
			local a, b = child:GetSize()	
			child.Text:SetPoint("BOTTOM", child, 0, 4)
			child:SetSize(a, b - 15)		
			child:SetPoint("TOPLEFT", MeetingHornMainPanel, "BOTTOMLEFT", 0, -1)
			child:SkinButton(true)
		elseif k >= 13 and k <= 18 then	
			local a, b = child:GetSize()
			child.Text:SetPoint("BOTTOM", child, 0, 4)
			child:SetSize(a, b - 15)	
			child:SetPoint("TOPLEFT", MeetingHornMainPanel, "BOTTOMLEFT", ((k-12) * 100), -1)
			child:SkinButton(true)
		end
	end

	hooksecurefunc(ListView, "GetButton", function(self, index)
		local button = self._buttons[index]
		if button and not button.styled then
			if button.Signup then
				button.Signup:SkinButton()
				button.Signup:SetSize(60, 20)
			end
			button.styled = true
		end
	end)

	local StripAllTextures = {
		MeetingHornDataBroker,
		MeetingHornMainPanel,
		MeetingHornMainPanel.Loading,
		MeetingHornMainPanel.Browser,
		MeetingHornMainPanel.Browser.QRTooltip,
		MeetingHornMainPanel.Browser.ProgressBar,
		MeetingHornMainPanel.Browser.Activity,
		MeetingHornMainPanel.Browser.ActivityList,
		MeetingHornMainPanel.Browser.Empty,
		MeetingHornMainPanel.Browser.Mode,
		MeetingHornMainPanel.Browser.Header1,
		MeetingHornMainPanel.Browser.Header2,
		MeetingHornMainPanel.Browser.Header3,
		MeetingHornMainPanel.Browser.Header4,
		MeetingHornMainPanel.Browser.Header5,
		MeetingHornMainPanel.Browser.Header6,
		MeetingHornMainPanel.Manage,
		MeetingHornMainPanel.Manage.Creator,
		MeetingHornMainPanel.Manage.Creator.Activity,
		MeetingHornMainPanel.Manage.Creator.Mode,
		MeetingHornMainPanel.Manage.Creator.Comment,
		MeetingHornMainPanel.Manage.Creator.Comment.ScrollFrame,
		MeetingHornMainPanel.Manage.Chat,
		MeetingHornMainPanel.Manage.Chat.ChatFrame,
		MeetingHornMainPanel.Manage.Chat.ChatBg,
		MeetingHornMainPanel.Encounter,
		MeetingHornMainPanel.Encounter.Instance,
		MeetingHornMainPanel.Encounter.BossList,
		MeetingHornMainPanel.Recent,
		MeetingHornMainPanel.Recent.Instance,
		MeetingHornMainPanel.Recent.Left,
		MeetingHornMainPanel.Recent.Members,
		MeetingHornMainPanel.Recent.Right,
		MeetingHornMainPanel.Recent.QRCode,
		MeetingHornMainPanel.Recent.QRCode.CodeFrame,
		MeetingHornMainPanel.Challenge,
		MeetingHornMainPanel.Challenge.Left,
		MeetingHornMainPanel.Challenge.Body,
		MeetingHornMainPanel.Challenge.Summary,
		MeetingHornMainPanel.Help,
		MeetingHornMainPanel.Options,
		MeetingHornMainPanel.Options.Options,
		MeetingHornMainPanel.Options.Filters,
		MeetingHornMainPanel.Options.Filters.FilterInputBox,
	}

	local SetTemplate1 = {
		MeetingHornMainPanel,
		--MeetingHornMainPanel.Browser,
		MeetingHornMainPanel.Manage,		
		MeetingHornMainPanel.Recent,	
		MeetingHornMainPanel.Options,			
		MeetingHornMainPanel.Challenge,	
		MeetingHornMainPanel.Options.Filters.FilterInputBox,
	}

	local SetTemplate2 = {
		MeetingHornMainPanel.Loading,
		MeetingHornMainPanel.Browser.QRTooltip,
		MeetingHornMainPanel.Browser.Activity,
		MeetingHornMainPanel.Browser.Mode,
		MeetingHornMainPanel.Browser.ActivityList,
		MeetingHornMainPanel.Browser.Empty,
		MeetingHornMainPanel.Browser.Header1,
		MeetingHornMainPanel.Browser.Header2,
		MeetingHornMainPanel.Browser.Header3,
		MeetingHornMainPanel.Browser.Header4,
		MeetingHornMainPanel.Browser.Header5,
		MeetingHornMainPanel.Browser.Header6,
		MeetingHornMainPanel.Manage.Creator,
		MeetingHornMainPanel.Manage.Creator.Activity,
		MeetingHornMainPanel.Manage.Creator.Mode,
		--MeetingHornMainPanel.Manage.Creator.Comment,
		MeetingHornMainPanel.Manage.Creator.Comment.ScrollFrame,
		MeetingHornMainPanel.Manage.Chat,
		--MeetingHornMainPanel.Manage.Chat.ChatFrame,
		--MeetingHornMainPanel.Manage.Chat.ChatBg,
		MeetingHornMainPanel.Encounter,		
		MeetingHornMainPanel.Encounter.BossList,
		MeetingHornMainPanel.Encounter.Instance,		
		MeetingHornMainPanel.Recent.Instance,
		MeetingHornMainPanel.Recent.Right,
		MeetingHornMainPanel.Recent.Left,
		MeetingHornMainPanel.Recent.Members,
		MeetingHornMainPanel.Recent.QRCode,
		MeetingHornMainPanel.Recent.QRCode.CodeFrame,
		MeetingHornMainPanel.Challenge.Left,		
		MeetingHornMainPanel.Challenge.Body,
		MeetingHornMainPanel.Challenge.Summary,
		MeetingHornMainPanel.Options.Options,
		MeetingHornMainPanel.Options.Filters.FilterList,
		MeetingHornMainPanel.Help,
	}

	local Buttons = {
		MeetingHornMainPanel.Browser.Reset,
		MeetingHornMainPanel.Browser.Refresh,
		MeetingHornMainPanel.Manage.Creator.CreateButton,
		MeetingHornMainPanel.Manage.Creator.CloseButton,
		MeetingHornMainPanel.Recent.Invite,
		MeetingHornMainPanel.Options.Filters.Add,
		MeetingHornMainPanel.Options.Filters.Import,
		MeetingHornMainPanel.Options.Filters.Export,
		MeetingHornMainPanel.FeedBack.AcceptButton,
		MeetingHornMainPanel.FeedBack.CancelButton,
		MeetingHornMainPanel.Challenge.Body.Reward.Exchange,
		MeetingHornMainPanel.Challenge.Body.Reward.View,
		MeetingHornMainPanel.Challenge.Body.UpdateButton,
		MeetingHornMainPanel.Challenge.Body.WebButton,
	}

	local NextPrevButton = {
		MeetingHornMainPanel.Browser.Activity.MenuButton,
		MeetingHornMainPanel.Browser.Mode.MenuButton,
		MeetingHornMainPanel.Manage.Creator.Activity.MenuButton,
		MeetingHornMainPanel.Manage.Creator.Mode.MenuButton,
		MeetingHornMainPanel.Challenge.Left.Groups.MenuButton,
		MeetingHornMainPanel.Encounter.Instance.MenuButton,
		MeetingHornMainPanel.Recent.Instance.MenuButton,
	}

	local DropDownBox = {
		MeetingHornMainPanel.Browser.Activity,
		MeetingHornMainPanel.Browser.Mode,
		MeetingHornMainPanel.Browser.Quick,
		MeetingHornMainPanel.Manage.Creator.Activity,
		MeetingHornMainPanel.Manage.Creator.Mode,
		MeetingHornMainPanel.Recent.Instance,
		MeetingHornMainPanel.Encounter.Instance,
		MeetingHornMainPanel.Challenge.Left.Groups,
	}

	local Editboxs = {
		MeetingHornMainPanel.Browser.Input,
		MeetingHornMainPanel.Options.Filters.FilterInputBox.Input,
	}

	local ScrollBars = {
		MeetingHornMainPanel.Browser.ActivityList.scrollBar,
		MeetingHornMainPanel.Manage.Chat.ChatFrame.scrollBar,
		MeetingHornMainPanel.Manage.Applicant.ApplicantList.scrollBar,
		MeetingHornMainPanel.Manage.Creator.Comment.ScrollFrame.ScrollBar,
		MeetingHornMainPanel.Encounter.BossList.scrollBar,
		MeetingHornMainPanel.FeedBack.EditBox.ScrollFrame.ScrollBar,
		MeetingHornMainPanelScrollBar,
		MeetingHornMainPanel.Recent.Members.scrollBar,
		MeetingHornMainPanel.Options.Filters.FilterList.scrollBar,
	}

	local Tabs = {		
	}

	for _, object in pairs(StripAllTextures) do
		object:StripTextures()
	end

	for k, object in pairs(SetTemplate1) do
		object:SetTemplate("Transparent")
	end

	for k, object in pairs(SetTemplate2) do
		object:SetTemplate("Overlay")
	end

	for _, object in pairs(Buttons) do
		object:SkinButton()
	end

	for _, object in pairs(NextPrevButton) do
		T.SkinNextPrevButton(object)
	end

	for _, object in pairs(DropDownBox) do
		--T.SkinDropDownBox(object)
	end

	for _, object in pairs(Editboxs) do
		T.SkinEditBox(object, 200, 18)
	end	

	for _, object in pairs(ScrollBars) do
		T.SkinScrollBar(object)
	end	

	for _, object in pairs(Tabs) do
		T.SkinTab(object)
	end	

	for _, object in pairs(DropDownBox) do

	end	

	MeetingHornMainPanel.FeedBackButton:Hide()
	MeetingHornMainPanel.Browser.ProgressBar:CreateBackdrop("Default")
	MeetingHornMainPanel.Browser.ProgressBar:SetStatusBarTexture(C.media.texture)
	T.SkinCloseButton(MeetingHornMainPanelCloseButton)
end