local T, C, L, _ = unpack(select(2, ...))
if C.trade.profession_tabs ~= true then return end

local tradeList = {
	2550,3102,3413,18260,3273,3274,7924,10846,2259,3101,3464,11611,
	2018,3100,3538,9785,7411,7412,7413,13920,4036,4037,4038,12656,
	2108,3104,3811,10662,2575,2576,3564,10248,3908,3909,3910,12180,2842
}

local myProfessions = {}
local tabList = {}

local function UpdateProfessions()
	myProfessions = {}
	for index, spellID in pairs(tradeList) do
		if IsPlayerSpell(spellID) then
			tinsert(myProfessions, spellID)
		end
	end
	if IsPlayerSpell(2575) or IsPlayerSpell(2576) or IsPlayerSpell(3564) or IsPlayerSpell(10248) then
		tinsert(myProfessions, 2656)
	elseif IsPlayerSpell(2550) or IsPlayerSpell(3102) or IsPlayerSpell(3413) or IsPlayerSpell(18260) then
		tinsert(myProfessions, 818)
	end
end

local function TradeTabs_Create()
	UpdateProfessions()
	for index, spellID in pairs(myProfessions) do
		local name = GetSpellInfo(spellID)
		local texture = GetSpellTexture(spellID)
		local tab = CreateFrame("CheckButton", "TradeTabs"..index, TradeSkillFrame, "SpellBookSkillLineTabTemplate, SecureActionButtonTemplate")
		tab.tooltip = name
		tab.spellID = spellID
		tab:SetAttribute("type", "spell")
		tab:SetAttribute("spell", name)
		tab:Show()

		if C.skins.blizzard_frames == true then
			tab:SetPoint("TOPLEFT", TradeSkillDetailScrollFrame, "TOPRIGHT", 28, (index * -50) + 80)
			tab:DisableDrawLayer("BACKGROUND")
			tab:SetNormalTexture(texture)
			tab:GetNormalTexture():ClearAllPoints()
			tab:GetNormalTexture():SetPoint("TOPLEFT", 2, -2)
			tab:GetNormalTexture():SetPoint("BOTTOMRIGHT", -2, 2)
			tab:GetNormalTexture():SetTexCoord(0.1, 0.9, 0.1, 0.9)
			tab:CreateBackdrop("Default")
			tab.backdrop:SetAllPoints()
			tab:StyleButton(true)
		else
			tab:SetPoint("TOPLEFT", TradeSkillDetailScrollFrame, "TOPRIGHT", 33, (index * -50) + 210)
			tab:SetNormalTexture(texture)
		end

		local cover = CreateFrame("Frame", nil, tab)
		cover:SetAllPoints()
		cover:EnableMouse(true)
		tab.cover = cover

		tinsert(tabList, tab)
	end
end

local function CraftTabs_Create()
	for index, spellID in pairs(myProfessions) do
		local name = GetSpellInfo(spellID)
		local texture = GetSpellTexture(spellID)
		local tab = CreateFrame("CheckButton", "TradeTabs"..index, CraftFrame, "SpellBookSkillLineTabTemplate, SecureActionButtonTemplate")
		tab.tooltip = name
		tab.spellID = spellID
		tab:SetAttribute("type", "spell")
		tab:SetAttribute("spell", name)
		tab:Show()

		if C.skins.blizzard_frames == true then
			tab:SetPoint("TOPLEFT", CraftDetailScrollFrame, "TOPRIGHT", 28, (index * -50) + 80)
			tab:DisableDrawLayer("BACKGROUND")
			tab:SetNormalTexture(texture)
			tab:GetNormalTexture():ClearAllPoints()
			tab:GetNormalTexture():SetPoint("TOPLEFT", 2, -2)
			tab:GetNormalTexture():SetPoint("BOTTOMRIGHT", -2, 2)
			tab:GetNormalTexture():SetTexCoord(0.1, 0.9, 0.1, 0.9)
			tab:CreateBackdrop("Default")
			tab.backdrop:SetAllPoints()
			tab:StyleButton(true)
		else
			tab:SetPoint("TOPLEFT", CraftDetailScrollFrame, "TOPRIGHT", 33, (index * -50) + 210)
			tab:SetNormalTexture(texture)
		end

		local cover = CreateFrame("Frame", nil, tab)
		cover:SetAllPoints()
		cover:EnableMouse(true)
		tab.cover = cover

		tinsert(tabList, tab)
	end
end

local function TradeTabs_Update()
	for _, tab in pairs(tabList) do
		local spellID = tab.spellID
		if IsCurrentSpell(spellID) then
			tab:SetChecked(true)
			tab.cover:Show()
		else
			tab:SetChecked(false)
			tab.cover:Hide()
		end
	end
end

local B = CreateFrame("Frame")
B:RegisterEvent("ADDON_LOADED")
B:RegisterEvent("TRADE_SKILL_SHOW")
B:RegisterEvent("TRADE_SKILL_CLOSE")
B:RegisterEvent("CURRENT_SPELL_CAST_CHANGED")
B:SetScript("OnEvent",  function(self, event) 
	if event == "ADDON_LOADED" then
		TradeTabs_Create()
		CraftTabs_Create()
	else
		TradeTabs_Update()
	end
end)